/*
 * $Id: Signal_get_size.cpp 113 2009-04-14 18:39:12Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/include/Signal.h"
#include "Common/include/Environment.h"

namespace morpheo              {
namespace behavioural          {

#undef  FUNCTION
#define FUNCTION "Signal::get_size"
  uint32_t Signal::get_size (void)
  {
    log_printf(FUNC,Behavioural,FUNCTION,"Begin");
    uint32_t _return = _size;

#ifdef MODELSIM_COSIMULATION
    switch (_type_info)
      {
      case BOOL     : _return =  1; break;
      case UINT8_T  : _return =  8; break;
      case UINT16_T : _return = 16; break;
      case UINT32_T : _return = 32; break;
      case UINT64_T : _return = 64; break;
      default       : break;
      }
#endif

    log_printf(FUNC,Behavioural,FUNCTION,"End");

    return _return;
  };

}; // end namespace behavioural          
}; // end namespace morpheo              
